import std.stdio;

void main()
{
    writeln(typeid(typeof("Hello, world!")));           // immutable(char)[]

    immutable(char)[] str = "One";
    str = "Two";
    writeln(typeid(typeof(str)));                       // immutable(char)[]

    immutable(char)[3] a = "Hi!";
    immutable(char)[] b = a;
    writeln(a.length, " ", b.length);                   // 3 3

    wstring x = "Здрав­ст­вуй, ши­ро­кий мир!";
    writeln(typeid(typeof(x)));                         // immutable(wchar)[]
    dstring y = "Здрав­ст­вуй, еще бо­лее ши­ро­кий мир!";
    writeln(typeid(typeof(y)));                         // immutable(dchar)[]
}
